import { graphql } from 'graphql-compose';

var GraphQLID = graphql.GraphQLID,
    GraphQLNonNull = graphql.GraphQLNonNull,
    GraphQLInterfaceType = graphql.GraphQLInterfaceType;


var NodeInterface = new GraphQLInterfaceType({
  name: 'Node',
  description: 'An object, that can be fetched by the globally unique ID among all types.',
  fields: function fields() {
    return {
      id: {
        type: new GraphQLNonNull(GraphQLID),
        description: 'The globally unique ID among all types.'
      }
    };
  },
  resolveType: function resolveType(payload) {
    // `payload.__nodeType` was added to payload via nodeFieldConfig.resolve
    return payload.__nodeType ? payload.__nodeType : null;
  }
});

export default NodeInterface;